VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   5385
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5655
   LinkTopic       =   "Form1"
   ScaleHeight     =   5385
   ScaleWidth      =   5655
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox Check5 
      Caption         =   "In den Papierkorb verschieben"
      Height          =   255
      Left            =   2880
      TabIndex        =   8
      Top             =   4560
      Width           =   2775
   End
   Begin VB.CheckBox Check4 
      Caption         =   "Nur Besttigungsdialog"
      Height          =   255
      Left            =   2880
      TabIndex        =   7
      Top             =   4320
      Width           =   2415
   End
   Begin VB.CheckBox Check3 
      Caption         =   "Ohne jeden Dialog"
      Height          =   255
      Left            =   2880
      TabIndex        =   6
      Top             =   4080
      Width           =   2655
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Nur den Fortschritt anzeigen"
      Height          =   255
      Left            =   2880
      TabIndex        =   5
      Top             =   3840
      Width           =   2535
   End
   Begin VB.DirListBox Dir1 
      Height          =   3015
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   2655
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Ordner und Dateien generieren"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   4920
      Width           =   2655
   End
   Begin VB.FileListBox File1 
      Height          =   1650
      Left            =   120
      TabIndex        =   3
      Top             =   3240
      Width           =   2655
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Dateien Lschen"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2880
      TabIndex        =   2
      Top             =   4920
      Width           =   2655
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Mit Unterverzeichnissen lschen"
      Height          =   255
      Left            =   2880
      TabIndex        =   1
      Top             =   3600
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Private Declare Function SHFileOperation Lib "shell32.dll" _
        Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) _
        As Long

Private Type SHFILEOPSTRUCT
  Hwnd As Long
  wFunc As Long
  pFrom As String
  pTo As String
  fFlags As Integer
  fAnyOperationsAborted As Boolean
  hNameMappings As Long
  lpszProgressTitle As String
End Type

Const FO_MOVE = &H1
Const FO_COPY = &H2
Const FO_DELETE = &H3
Const FO_RENAME = &H4

Const FOF_MULTIDESTFILES = &H1
Const FOF_CONFIRMMOUSE = &H2
Const FOF_SILENT = &H4
Const FOF_RENAMEONCOLLISION = &H8
Const FOF_NOCONFIRMATION = &H10
Const FOF_WANTMAPPINGHANDLE = &H20
Const FOF_ALLOWUNDO = &H40
Const FOF_FILESONLY = &H80
Const FOF_SIMPLEPROGRESS = &H100
Const FOF_NOCONFIRMMKDIR = &H200

Private Sub Command1_Click()
  Call MakeFiles
End Sub

Private Sub Command2_Click()
  Dim Files$
  Dim SFO As SHFILEOPSTRUCT
    
    MousePointer = vbHourglass
    
    Command1.Enabled = False
    Command2.Enabled = False
    DoEvents
    
    Files = Files & App.Path & "\Test\*.*" & Chr$(0)
    Files = Files & Chr$(0)
    
    With SFO
      .Hwnd = Me.Hwnd
      .wFunc = FO_DELETE
      .pFrom = Files
      .pTo = "" & Chr$(0)
      
      'keine Unterverzeichnisse
      If Check1.Value = vbUnchecked Then .fFlags = FOF_FILESONLY
      
      'Fortschritt anzeigen
      If Check2.Value = vbChecked Then _
                        .fFlags = .fFlags Or FOF_SIMPLEPROGRESS
      
      'Dialog anzeigen
      If Check3.Value = vbChecked Then _
                        .fFlags = .fFlags Or FOF_NOCONFIRMATION
      
      'Nur Besttigungsdialog zum Lschen
      If Check4.Value = vbChecked Then _
                        .fFlags = .fFlags Or FOF_SILENT
      
      'In den Papierkorb statt lschen
      If Check5.Value = vbChecked Then _
                        .fFlags = .fFlags Or FOF_ALLOWUNDO
    End With

    Call SHFileOperation(SFO)
    File1.Refresh
    If Check1.Value = vbChecked Then
      Dir1.Path = App.Path & "\Test"
      Dir1.Refresh
    End If
    
    If SFO.fAnyOperationsAborted Then
      Call MsgBox("Enige Operationen wurden nicht ausgefhrt!")
    End If
    
    MousePointer = vbDefault
    Command1.Enabled = True
End Sub

Private Sub MakeFiles()
  Dim x&, y&, FN%, aa$, bb$
    
    Command1.Enabled = False
    Command2.Enabled = False
    DoEvents
    
    MousePointer = vbHourglass
    
    'Ein paar Ordner und Dateien erstellen
    bb = App.Path & "\Test"
    If Len(Dir$(bb, vbDirectory)) = 0 Then
      MkDir bb
    End If
    
    aa = String(1024, "x")
    For y = 0 To 500
      FN = FreeFile
      Open bb & "\File" & CStr(y) & ".txt" For Output As #FN
        Print #FN, aa
      Close FN
    Next y
    
    If Dir$(bb & "\Ordner1", vbDirectory) = "" Then
      MkDir bb & "\Ordner1"
    End If
    
    If Dir$(bb & "\Ordner1\Ordner2", vbDirectory) = "" Then
      MkDir bb & "\Ordner1\Ordner2"
    End If

    File1.Path = bb
    File1.Refresh
    
    Dir1.Path = bb & "\Ordner1\Ordner2"
    Dir1.Refresh
    
    MousePointer = vbDefault
    Command2.Enabled = True
End Sub
